<?php 
require ("../lib-abdesk.php");
CheckCookie();
?>
<html><head><title>ABDesktop Dangerous Functions</title></html>
<link rel=stylesheet href="css/a.css" type="text/css"></head>
<body>
<center>
<?php ListNav(); 
?>
<p>
<h1>ABDesktop Dangerous Functions</h1>
<p>
<div class='navanchs'><a href="#all">All</a> - <a href="#links">Links DB</a> - <a href="#ideas">Idea DB</a> - <a href="#files">File DB</a></div>
<p>
Below the line are some dangerous functions you probably won't be using that often.
<p>
Before doing anything that will drastically affect the data in your database, you should make a backup copy of your database. This can be done by saving a copy of your databases' folders located in <code>C:\xampp\mysql\data</code>, along with a backup copy of <code>C:\xampp\htdocs\abdesk-data</code>. (That's the folder which contains thumbnails and file browsers created by the Astroblahhh File Organizer, and any databases exported using a script like the Export Ideas DB script).
<p>
Anything in the "abdesk-dangerous" folder can, and probably should, be removed from the "abdesk" folder and put someplace inaccessible to XAMPP, outside of the "htdocs" or "xampp" folders, if you have no specific use for the scripts there.
<p>
Of course, if you've moved your "abdesk-dangerous" directory somewhere else, a lot of the below links might not work.
<p>
<br>
<a name="all"></a>
<hr width=25%>
<p>
<center><h2>All</h2>
<p>
<a href="../sessionvars-show.php" class="arlink">Session Vars - Show</a> - This isn't dangerous, it's just here for convenience.
<p>
<a href="../sessionvars-delete.php" class="arlink">Session Vars - Delete</a> - This is dangerous, if you don't want to delete your session variables.  However, it's a good idea to run this if you changed the database you're using, so ABDesktop won't get tags from the old database mixed up with the new database.
<p>
By the way - the way to change databases is by  modifying the variable(s) $filesdb_name, $linksdb_name, and/or $ideas_dbname in lib-abdesk.php.  Someday I'll probably get around to making a more official, tidy way to change over to a separate database than editing source code and having to manually run this script to delete the session variables.

<p>
<br>
<a name="links"></a>
<hr>
<p>
<b>The Nuke/Make New Database scripts</b> - Dangerous because if you click the Nuke button, your links DB, idea DB or file DB will be instantaneously wiped out, which is irreversible unless you made a backup copy of your database.  The Make New Database Tables button creates fresh, new, empty database tables.
<p>
These scripts will be most useful to you if you're just testing out ABDesktop with scratch databases to learn how to use it, or, if you're altering ABDesktop's code, and need to quickly wipe out and recreate the DBs repeatedly in the process of developing and debugging your code.
<p>
<hr width=25%>
<p>
<center><h2>Links DB</h2>
<p>
<a href="nukeandmakenew-linksdb.php" class="arlink">Nuke Links DB and/or Make New Database Tables</a>
<p>
<br>
<a name="ideas"></a>
<hr width=25%>
<p>
<center><h2>Idea DB</h2>
<p>
<a href="nukeandmakenew-ideasdb.php" class="arlink">Nuke Idea DB and/or Make New Database Tables</a>
<p>
<br>
<a name="files"></a>
<hr width=25%>
<p>
<center><h2>File DB</h2>
<p>
<a href="nukeandmakenew-filedb.php" class="arlink">Nuke File DB and/or Make New Database Tables</a>
<p>
<?php ListNav(); 
?>