<?php

require ("../lib-abdesk.php");

CheckCookie();

session_start();

require ("../lib-files.php");

function GoBackToFormWithError($err)
{
	$_SESSION[error]=$err;
	header("Location: file_adder_form.php");
	exit;
}
if ($setphpdefaults)
{
	ini_set("memory_limit", "$phpmem");
	ini_set("max_execution_time", "$phpmaxexec");
	//echo ini_get("memory_limit");
}

if ($fileadder_active!="yes")
{
	GoBackToFormWithError("fileadder inactive");
	exit;
}
	$add=$_POST[add];
	$edited=$_POST[edited];

if (!$add && !$edited)
{	
	$add_dirfiles=$_GET[a];
	$make_tns=$_GET[tn];
	$thispath=$_GET[p];
	$make_bmp_tns=$_GET[b];
	$disknick=$_GET[dn];
}
else
{
//In case the user gets sent back to the form, this makes it so their original
//input is preserved:

	$varstoget_fromform=array("thispath", "add_dirfiles", "make_tns", "make_bmp_tns", "editquery", "disknick");

	foreach ($varstoget_fromform as $varname)
		{
			$_SESSION[$varname]=$_POST[$varname];
			${$varname}=$_POST[$varname];
		}
}
if ($edited)
{
	if (!$editquery)
	{	GoBackToFormWithError("no edit commands");
		exit;
	}
}

$rawpath = $thispath;
if (!$make_bmp_tns)
{	$bmp_library_installed="no";
}

$set=1;
$processed_path = ProcessRawFilepath($rawpath, $set); //in lib-files.php

$diskpath=$processed_path;

if (!file_exists($diskpath))
{	
	GoBackToFormWithError("nonexistent fileordir");
	exit;
}

$handle=ConnectToDb($filesdb_name);

if ($edited)
{
	require ("lib-mass_editor.php");
	require ("lib-search.php");
	require ("../lib-tags.php");
	$editquery_part2=ParseEditQuery($editquery);
	$editquery_part2=substr($editquery_part2, 2);
	$getvareditquery=ereg_replace("\r\n", ";;", $editquery);
	
	if (!$editquery_part2 && !$changed_tagtypes)
	{	GoBackToFormWithError("no edit query");
		exit;
	}	
}

echo "<html><head><title>ABDesktop File Adder</title>
<link rel=stylesheet href=\"css/f.css\" type=\"text/css\">
<style type=\"text/css\"> 
</style></head><body><center>";

ListNav();

echo "<h1>ABDesktop File Adder</h1>
<p>
<big>$diskpath</big>
<p>";


//Regardless of whether it's a directory or a file, we first want to see if it already exists in the db.

GetPathinfo($diskpath, $set);
CleanAndEncloseOrIsNullPathinfo($set);

if ($itemtype[$set]=="File")
{
	$query_to_issue = "SELECT file_id FROM FileInfo WHERE ( $cleandisk[$set] AND $cleanparentdirs[$set] AND $cleanfilename[$set] AND $cleanext[$set] AND itemtype='$itemtype[$set]')";
}
else
{	$query_to_issue = "SELECT file_id FROM FileInfo WHERE ( $cleandisk[$set] AND $cleanparentdirs[$set] AND $cleanfilename[$set] AND itemtype='$itemtype[$set]' )";
}
echo "$query_to_issue<p>";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

//Just some setting up before we act on the knowledge we just gained...

$Insert_Filedetails_querystart="INSERT INTO
	FileInfo (filesize, extcat, itemtype, disknick, disk, parentdirs, filename, ext, filelm, filecr, paired, pairedname, repository, contentsimported, privacy, licensetype, whenadded, lastread, importdate) VALUES ";
	
$Insert_ImageDetails_querystart = "INSERT INTO
	ImageInfo (file_id, width, height, area, aspectratio, reverse_aspectratio, wideortall, showthumbnail, hasthumbnail) VALUES ";

	$repository="y";   //placed in repository by default.
	$privacylevel=6;  //default privacy level: 5, undecided.
	$licensetype=5;  //default license type 4, unknown.
	$whenadded="now()";
	$lastread="now()";
	$rawitemtype=$itemtype[$set];
	CleanInput($disknick);
	$disknick=EncloseOrNull($disknick, "'");


if (mysql_num_rows($query_result) < 1)
	//Then, the item the user put in doesn't exist in the database yet, so we will insert all its details.
{
	echo "Added to database!";
	
	GetFileDetails($diskpath, $set); //in lib-files.php
	
	
	GetFileSizeAndDates($diskpath, $set);
	EncloseOrNullFileSizeAndDates($set);

	$rawextcat=$extcat[$set];
	$rawext=$ext[$set];
	
	CleanFileDetails($set);
	EncloseOrNullFileDetails($set);
	
	if ($rawitemtype=="Dir" && $add_dirfiles=="y")
	{	$contentsimported="n";
		$importdate="null"; //for now; just in case it gets stopped in the middle.
	}
	else
	{	$contentsimported="n";
	}
	EncloseOrNullOtherDetails();
	
	$query_to_issue = $Insert_Filedetails_querystart . " ($filesize[$set], $extcat[$set], $itemtype[$set], $disknick, $disk[$set], $parentdirs[$set], $filename[$set], $ext[$set], $filelm[$set], $filecr[$set], $paired[$set], $pairedname[$set], $repository, $contentsimported, $privacylevel, $licensetype, $whenadded, $lastread, $importdate) ";
	
	echo "<p>$query_to_issue";
	
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
	
	$mainpath_id=mysql_insert_id();
	$runeditonmainpath=true;
	
		//If we're adding a single file, we run the edit query now.

	if ($edited && $runeditonmainpath && !$add_dirfiles) //&& $rawitemtype=="File"
	{
		$result=ExecuteMassEdit("adder", $mainpath_id, 1);
		
		//PrintArr($in_tags);
		
		$getvareditquery=ereg_replace("\n", ";;", $editquery);
		DisplayWithNotif($getvareditquery);
	
		if ($notif=="edit exec")
		{	EchoNotif("Your edit query, <b>$_SESSION[notifdisp]</b>, has been executed.<p><br>Queries issued: <p>$queries_issued");
		}
	}
	
	
	if ($rawextcat=="Image")
	{	
		$lowercaserawext=strtolower($rawext);
		if ($bmp_library_installed=="yes" && $lowercaserawext=="bmp")
		{	require("../lib-bmp.php");
			$bmp_lib_included="yes";
		}
		if ($make_tns=="y")
		{	
			MakeThumbnail($diskpath, $rawext, $mainpath_id);
		}
		else
		{	$showthumbnail[$set]="y";
			$hasthumbnail[$set]="n";
		}
		EncloseOrNullImageDetails($set);
		$query_to_issue = $Insert_ImageDetails_querystart . " ($mainpath_id, $imagewidth[$set], $imageheight[$set], $imagearea[$set], $aspectratio[$set], $reverse_aspectratio[$set], $wideortall[$set], $showthumbnail[$set], $hasthumbnail[$set]) ";
		echo "<p>$query_to_issue";
		
		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
	}
}
else
{	//$argh = mysql_fetch_array($query_result);
	//$vartoget=array("file_id");
	//PrintQueryResultGrid($query_result, $vartoget);

	//$mainpath_id=$argh['file_id'];
	$mainpath_id=mysql_result($query_result,0,'file_id');
	echo "Already in database, so not re-added. ";
	echo "Mainpath id: $mainpath_id<p><br>";
}
	//echo "Rawitemtype: $rawitemtype "; echo "Add_dirfiles $add_dirfiles";
	
	//if importing contents now, though, we do want to update the existing entry with a new import date,
	//later, though, after we get the file size of the entire directory.
	if ($rawitemtype=="Dir" && $add_dirfiles=="y")
	{
		$update_orig_path_size_and_impdate="yes";
	}
	
//OK, if the user imported only a single file or directory, then, we're actually done already.

if ($rawitemtype=="File")
{	echo "<p><br>Done.";
	exit;
}

//But, if the user imported a dir and wanted the contents added too, then, we now have to
//do that.  We next grab all the files in that dir and see which ones are
//already in the database, and add any new ones.

if ($rawitemtype=="Dir" && $add_dirfiles)
{
	GetPathinfo($diskpath, $set);
	CleanPathinfo($set);
	if ($cleanparentdirs[$set] || $cleanparentdirs[$set]==="0")
	{	$fileparentdirs = $cleanparentdirs[$set] . "/$cleanfilename[$set]";
	}
	else
	{	if (strpos($cleanfilename[$set], ":") )
		{	$fileparentdirs="isnull(parentdirs)";
		}
		else
		{
			$fileparentdirs = "parentdirs = '$cleanfilename[$set]'";
		}
		echo "DIE $fileparentdirs ";
	
	}
	$query_to_issue = "SELECT filename, ext, filesize FROM FileInfo WHERE disknick=$disknick AND disk='$cleandisk[$set]' AND $fileparentdirs";
	
	echo "Results of trying to add contents of the above path:<p>";
	
	echo "<p>$query_to_issue";

	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

	//	$dirfiles=scandir($diskpath);
	
	$dirhandle=opendir($diskpath);
	$zz=0;
	//The reason we go to all this trouble instead of just using scandir
	//is because scandir does an automatic sort on the array which 
	//actually incorrectly puts the items _out_ of alphabetical order.
	//This way puts them in the correct order.
	while (false !== ($thisfile = readdir($dirhandle)))
	{	$dirfiles[$zz]=$thisfile;
		$zz++;
	}
	
	closedir($dirhandle);
	natcasesort($dirfiles);
	
	//PrintArr($dirfiles);
	$dots_to_exclude=array(".", "..");

	$dirfiles = array_diff($dirfiles, $dots_to_exclude);

	$dirfiles = array_merge($dirfiles);

	$num_of_actual_files=count($dirfiles);
	$quantity=$num_of_actual_files;

	$x=0;
	$folder_total_filesize=0;

	if (mysql_num_rows($query_result) > 0)
	{	//If any files were already in the database, we retrieve their details.
		while ($fileinfo = mysql_fetch_array($query_result))
		{	
			$thisfn=$fileinfo[filename];
			$thisext=$fileinfo[ext];

			$thisfilesize=$fileinfo[filesize];
			
			$folder_total_filesize += $thisfilesize;
			
			if ($thisfn && $thisext)
			{	
				$array_files_in_db[$x]="$thisfn.$thisext";
			}
			else if ($thisfn && !$thisext)
			{	
				if ($thisext!=null)
				{	
					$array_files_in_db[$x]="$thisfn.0";
				}
				else
				{	$array_files_in_db[$x]="$thisfn";
				}
			}
			else if (!$thisfn && $thisext)
			{	
				if ($thisfn!=null)
				{	
					$array_files_in_db[$x]="0.$thisext";
				}
				else
				{	$array_files_in_db[$x]=".$thisext";
				}
			}
			else if (!$thisfn && !$thisext)
			{	
				if ($thisfn!=null && $thisext!=null)
				{	$array_files_in_db[$x]="0.0";
				}
				else if ($thisfn!=null && $thisext==null)
				{	$array_files_in_db[$x]="0";
				}
				else if ($thisfn==null && $thisext!=null)
				{	$array_files_in_db[$x]=".0";
				}
			}
			$x++;
		}
		//Then we figure out which of the dirfiles are already in the database.
		$array_oldfiles = array_intersect($dirfiles, $array_files_in_db);

		//This bit here is just to make the index continuous instead of having gaps:
		$array_oldfiles =array_merge($array_oldfiles);

		//Then we find out which dirfiles aren't in the database yet and need to be added.
		$array_newfiles = array_diff($dirfiles, $array_files_in_db);

		$array_newfiles = array_merge($array_newfiles);

		//Only the new files need to be inserted into the FileInfo table.  The old
		//files' entries can be left alone.  We're not even going to bother updating
		//the old files' dates or sizes, or anything else of the old files.
	}
	else	//If there are no rows, then there are no existing records, so
			//all the files in the directory are new to the database.
	{
		$array_newfiles=$dirfiles;
	}

	$x=0;

	//OK, now we handle the addition of the new files.

	$numofnewfiles=count( $array_newfiles );
	$numofoldfiles=count( $array_oldfiles );

	echo "<pre>";
	PrintArr($array_newfiles, "$numofnewfiles New Files:");
	PrintArr($array_oldfiles, "$numofoldfiles files already in DB:");
	
	$query_to_issue = $Insert_Filedetails_querystart;
	
	if ($numofnewfiles>0)
	{
		$y=0;

		while ($x<$numofnewfiles)
		{	$thisfile=$array_newfiles[$x];

			if ($thisfile == ".")
			{	"dot found this makes no sense";	//incredibly helpful error message
			}
			if ($thisfile == "..")
			{	"dots found WHY???????";
			}
		
			$thispath=$diskpath . "/" . $thisfile;
			$thispath=StripExtraSlashes($thispath);
			$thiscleanpath=$thispath;
			CleanInput($thiscleanpath);
			
			UnsetFileDetails($set);
			GetFileDetails($thispath, $set); //in lib-files.php
			GetFileSizeAndDates($thispath, $set);
			
			$folder_total_filesize += $filesize[$set];
			
			EncloseOrNullFileSizeAndDates($set);
		
			$rawitemtype=$itemtype[$set];
			$rawextcat=$extcat[$set];
			$rawext=$ext[$set];
		
			if ($rawextcat=="Image")
			{	$array_newimages[$y]=$thisfile;
				$imagespresent=true;
				if ($bmp_library_installed=="yes" && !$bmp_lib_included && !$bmps_present)
				{	$lowercaserawext=strtolower($rawext);
					if ($lowercaserawext=="bmp")
					{	$bmps_present="yes";
					}
				}
				$y++;
			}
		
			CleanFileDetails($set);
			EncloseOrNullFileDetails($set);
	
			$contentsimported="n";
			$importdate="";
			$repository="y";
			EncloseOrNullOtherDetails();

			$query_to_issue .= " ($filesize[$set], $extcat[$set], $itemtype[$set],  $disknick, $disk[$set], $parentdirs[$set], $filename[$set], $ext[$set], $filelm[$set], $filecr[$set], $paired[$set], $pairedname[$set], $repository, $contentsimported, $privacylevel, $licensetype, $whenadded, $lastread, $importdate),\n\n";

			$x++;
		}
	
		$query_to_issue=substr($query_to_issue, 0, -3);
		echo "<p><pre>$query_to_issue<p>";
		
		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
		$insertedfileid=mysql_insert_id();

		//now, we want to update the original file path with a new import date,
	//set contentsimported to 'y', and add the file size - the total memory taken up 
	//by all the files in the folder.

if ($update_orig_path_size_and_impdate=="yes")
{
	$dirquery="</b><p><br>Updating import date and dir file size:</b><p>";
	$query_to_issue="update fileinfo set contentsimported='y', importdate=now(), filesize=$folder_total_filesize, quantity=$quantity where file_id=$mainpath_id limit 1";
	$dirquery.="<p>$query_to_issue ";
	echo $dirquery;
	
	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
}

//OK, now we execute the edit query before doing the image stuff.  The image
//stuff is the stuff most likely to fail, so we might as well get the edit query executed
//before the script possibly gets halted.

	if ($edited)
	{
		if ($runeditonmainpath)
		{	$result=ExecuteMassEdit("adder", $mainpath_id, $numofnewfiles+1);
		}
		else
		{
			$result=ExecuteMassEdit("adder", $insertedfileid, $numofnewfiles);
		}
		
		DisplayWithNotif($getvareditquery);
	
		if ($notif=="edit exec")
		{	EchoNotif("Your edit query, <b>$_SESSION[notifdisp]</b>, has been executed.<p><br>Queries issued: <p>$queries_issued");
		}
	}

	
	//Next, the image stuff.	
		if ($imagespresent)
		{
			if ($bmp_library_installed=="yes" && !$bmp_lib_included && $bmps_present=="yes")
			{	require("../lib-bmp.php");
			}
			$x=0;
			$query_to_issue=$Insert_ImageDetails_querystart;
			
			$allimageids=array();
			$allimagexts=array();
			$numofnewimages=count( $array_newimages );
			PrintArr($array_newimages, "$numofnewimages New Images:");
			while ($x<$numofnewimages)
			{
				$key=array_search($array_newimages[$x], $array_newfiles);
				$thisfile=$array_newimages[$x];
				$thisfileid=$insertedfileid+$key;
				$allimageids[$x]=$thisfileid;
				
				$thispath=$diskpath . "/" . $thisfile;
				$thispath=StripExtraSlashes($thispath);
				$thiscleanpath=$thispath;
				CleanInput($thiscleanpath);
				
				UnsetFileDetails($set);
				UnsetImageDetails($set);
				GetFileDetails($thispath, $set); //in lib-files.php
				$rawext=$ext[$set];
				$allimagexts[$x]=$rawext;
				$allshowtn[$x]=$showthumbnail[$set];
					
				if ($make_tns=="y")
				{
					//$showthumbnail[$set]="y";
					$hasthumbnail[$set]="n";
					//MakeThumbnail($thispath, $rawext, $thisfileid);
					//Used to make them here but it's better to do them later.
				}
				else
				{	//$showthumbnail[$set]="y";
					$hasthumbnail[$set]="n";
				}
				EncloseOrNullImageDetails($set);
			
				$query_to_issue .= " ($thisfileid, $imagewidth[$set], $imageheight[$set], $imagearea[$set], $aspectratio[$set], $reverse_aspectratio[$set], $wideortall[$set], $showthumbnail[$set], $hasthumbnail[$set]),\n\n";
			//	echo "<p>echo $query_to_issue";
				$x++;
			}
			$query_to_issue=substr($query_to_issue, 0, -3);
			echo "<p><b>Image query:</b>
			<p>
			$query_to_issue";
			$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
		
			
			//It's way safer to do the thumbnail stuff last after
			//the imageinfo query has been sent already.
			
			if ($make_tns=="y")
			{
				$x=0;
				foreach ($allimageids as $thisfileid)
				{
					$thisfile=$array_newimages[$x];
					$thispath=$diskpath . "/" . $thisfile;
					$thispath=StripExtraSlashes($thispath);
					$rawext=$allimagexts[$x];
					$rawshowtn=$allshowtn[$x];
					echo "Thisfile: $thisfile ";
					if ($rawshowtn=="y")
					{
						$madetn=MakeThumbnail($thispath, $rawext, $thisfileid);
					}
					$lowercasext=strtolower($rawext);
				//	if ($lowercasext!="bmp" || ($lowercasext=="bmp" && $make_bmp_tns)
					//{
					if ($madetn)
					{
						$query_to_issue="UPDATE imageinfo SET hasthumbnail='y' WHERE file_id=$thisfileid LIMIT 1";
						$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
					}
					$x++;
				}
			}
		echo $dirquery;
		}
	}
	//now, we want to update the original file path with a new import date,
	//set contentsimported to 'y', and add the file size - the total memory taken up 
	//by all the files in the folder.
	else
	{
		if ($update_orig_path_size_and_impdate=="yes")
		{
			$dirquery="</b><p><br>Updating import date and dir file size:</b><p>";
			$query_to_issue="update fileinfo set contentsimported='y', importdate=now(), filesize=$folder_total_filesize, quantity=$quantity where file_id=$mainpath_id limit 1";
			$dirquery.="<p>$query_to_issue ";
			echo $dirquery;
			
			$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());
		}
	}
}

echo "</pre></pre>";
ListNav();
?>