<?php

require ("../lib-abdesk.php");

CheckCookie();

session_start();

$handle=ConnectToDb($ideasdb_name);
$rawprevdbname=$_POST[dbname];

array_walk($_POST,'CleanInput');
$prevdbname=$_POST[dbname];

$prevformname="export_ideas_db_form";

function GoBackToFormWithError($err)
{	global $url_id, $prevformname;

	$_SESSION[error]=$err;
	header("Location: $prevformname.php");
	exit;
}

if (!$prevdbname)
{
	GoBackToFormWithError("enter prevdbname");
	exit;
}

function mysql_field_array( $query )
{	//Returns an array listing the table fields present in a query result.
	$field = mysql_num_fields( $query );

	for ( $i = 0; $i < $field; $i++ )
	{
		$names[] = mysql_field_name( $query, $i );
	}
	return $names;
}

//We start by getting all the idea details.  We don't need the tags or tagmap table,
//the needed tags will be created anew later during the import using the tagstrings.
//The related IDs will also be dealt with and changed to their proper new values
//by the import script.  (Once the import script is written, that is.)

	$query_to_issue="SELECT * from ideainfo
ORDER BY idea_id ASC";

$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

//Rather than manually writing a list of the table columns, we do it automatically.
$ideainfo_fields=mysql_field_array($query_result);

//There were a few fields that weren't supposed to be there that I forgot to
//take out of the nukeandmakenew script in earlier versions.  If the user hasn't
//removed them, then here, we exclude them from the output so the user doesn't
//have problems later.

//We also exclude Idea_id, since the ideas will all be assigned new IDs when 
//they're imported/merged into the other database.

$excludefields=array("idea_id", "redundant", "temphide", "projectag");

$ideainfo_insertfields=array_diff($ideainfo_fields, $excludefields);
array_push($ideainfo_insertfields, "mostrecentprevdb");
array_push($ideainfo_insertfields, "prevdb_idea_id");

$ideainfo_insertfields=array_iunique($ideainfo_insertfields);

$ideainfo_sqlvars=implode(", ", $ideainfo_insertfields);


//Next, we process the query results and construct the SQL insert
//queries for the output.
$numofresults=mysql_num_rows($query_result);

$querychunk=0;
$prevquerychunk=-1;


//Rather than escaping single quotes, etc. in every variable, we only
//want to escape these variables, since most of the other variables can't possibly
//contains single quotes, so no need to process them all.
//Would probably be better and more reliable to use the usual procedure for this.
$strings_to_escape=array("urls", "filepaths", "relatedids", "title", "bundlestring", "maintagstring", "othertagstring", "projectstring", "otherbundlestring", "authorstring", "languagestring", "locstring", "toforstring", "quote", "longdesc", "sourcenotes", "donenote", "othercomments", "notesonduedate", "maindatenotes", "daterangenotes", "mostrecentprevdb");

$x=0;
$semicolon="";
$semicolon2="";

$ideainfo_query=array();
$all_songids=array();

while ($idea_info = mysql_fetch_array($query_result) )
{
	if ($prevquerychunk<$querychunk)
	{	
		$ideainfo_query[$querychunk] = "$semicolon\n\nINSERT INTO

	ideainfo ($ideainfo_sqlvars)

	VALUES\n\n";
		$prevquerychunk=$querychunk;
		$semicolon=";";
	}
	$ideainfo_query[$querychunk] .= " (";

	foreach ($ideainfo_insertfields as $field)
	{	${$field}=$idea_info[$field];
	}
	$mostrecentprevdb=$prevdbname;
	
	foreach ($strings_to_escape as $string)
	{
		${$string}=mysql_real_escape_string(${$string});
	}
		
	foreach ($ideainfo_insertfields as $field)
	{	if (${$field}!="")
		{
			$ideainfo_query[$querychunk] .= "'${$field}', ";
		}
		else
		{	$ideainfo_query[$querychunk] .= "NULL, ";
		}
	}
	$ideainfo_query[$querychunk] = substr($ideainfo_query[$querychunk], 0, -2);
	$ideainfo_query[$querychunk] .= "), \n\n ";
		
	$len=strlen($ideainfo_query[$querychunk]);

	if ($len>50000)	//If the insert query reaches over 50 KB, then, we start another.
	{
		$ideainfo_query[$querychunk] = substr($ideainfo_query[$querychunk], 0, -5);
		$prevquerychunk=$querychunk;
		$querychunk++;
	}
	$x++;
}

	$finalideainfo_query=implode(" ", $ideainfo_query);
	$finalideainfo_query = substr($finalideainfo_query, 0, -5);
	$finalideainfo_query .=";\n\n";

	if (!file_exists($exportdb_path) )
	{	mkdir( $exportdb_path );
	}
	$res=time();
	$date = date("Y_m_d-H,i,s", $res);
	
	$dbname=$ideasdb_name . "-$rawprevdbname-$date.txt";
	$finalpath=$exportdb_path . "/$dbname";
?>

<html><head><title>Ideas DB Exported</title>
<link rel=stylesheet href='css/i.css' type='text/css'>
</head>
<body><center>
<?php

IdeasNav();

?>
<p>
<h1>Ideas DB Exported</h1>
<p>
<?php

OverwriteFile($finalpath, $finalideainfo_query);

echo "<p>Prevdbname: $prevdbname";

?>