<?php

$max_tn_width=200;
$max_tn_height=200;

if ($setphpdefaults)
{
	ini_set("memory_limit", "$phpmem");
}

$tnableimageformats=array("bmp", "gif", "jpg", "jpeg", "png");

function RemoveFileLocalhost($path)
{
	$plainpath=explode("file://localhost/",$path);
	$res=$plainpath[1];

	return $res;
}

function EncloseOrNullFileDetails($set)
{
	$varstoenclose=array("disk", "parentdirs", "itemtype", "filename", "ext", "extcat", "paired", "pairedname");

	foreach ($varstoenclose as $var)
	{	global ${$var};
		${$var}[$set]=EncloseOrNull(${$var}[$set], "'");
	}
}

function EncloseOrNullFileSizeAndDates($set)
{	$varstoenclose=array("filesize", "filelm", "filecr");

	foreach ($varstoenclose as $var)
	{	global ${$var};
		${$var}[$set]=EncloseOrNull(${$var}[$set], "'");
	}
}

function EncloseOrNullOtherDetails()
{	$varstoenclose=array("importdate", "contentsimported", "repository", "privacylevel", "licensetype");
	foreach ($varstoenclose as $var)
	{	global ${$var};
		if (${$var}!="now()")
		{
			${$var}=EncloseOrNull(${$var}, "'");
		}
	}
}

function EncloseOrNullImageDetails($set)
{	
	$varstoenclose=array("imagewidth", "imageheight", "imagearea", "aspectratio", "reverse_aspectratio", "wideortall", "showthumbnail", "hasthumbnail");
	foreach ($varstoenclose as $var)
	{	global ${$var};
		${$var}[$set]=EncloseOrNull(${$var}[$set], "'");
	}
}


function GetFileSizeAndDates($diskpath, $set)
{	global $filelm, $filecr, $filesize;

	$itemtype=GetItemType($diskpath);
	$sizendates = stat($diskpath);

	$filelm[$set]=$sizendates['mtime'];
	$filecr[$set]=$sizendates['ctime'];

	$filelm[$set]=date("Y-m-d H:i:s", $filelm[$set]);
	$filecr[$set]=date("Y-m-d H:i:s", $filecr[$set]);
	
	if ($itemtype!="Dir")
	{
		$filesize[$set]=$sizendates['size'];
	}
	else
	{	$filesize[$set]="";
	}
}


function CleanFileDetails($set)
{	global $parentdirs, $filename, $ext, $pairedname;

	CleanInput( $parentdirs[$set] );
	CleanInput( $filename[$set] );
	CleanInput( $ext[$set]) ;
	CleanInput( $pairedname[$set]) ;
}


function CleanAndEncloseOrIsNullPathinfo($set)
{	global $disk, $parentdirs, $filename, $ext, $cleandisk, $cleanparentdirs, $cleanfilename, $cleanext;

	$varstoclean=array("disk", "parentdirs", "filename", "ext");
	
	foreach($varstoclean as $var)
	{
		$cleanvar="clean$var";
		//echo "Var: $var " . ${$var}[$set] ;
		${$cleanvar}[$set]=${$var}[$set];
		CleanInput(${$cleanvar}[$set]);
		${$cleanvar}[$set]=EncloseOrIsNull($var, ${$cleanvar}[$set], "'");
	}
}

function CleanPathinfo($set)
{	global $disk, $parentdirs, $filename, $ext, $cleandisk, $cleanparentdirs, $cleanfilename, $cleanext;

	$varstoclean=array("disk", "parentdirs", "filename", "ext");
	
	foreach($varstoclean as $var)
	{
		$cleanvar="clean$var";
		${$cleanvar}[$set]=${$var}[$set];
		CleanInput(${$cleanvar}[$set]);
	}
}

function VarArrays()
{	
	$vars=array("disk", "parentdirs", "filename", "ext", "itemtype");
	
	foreach ($vars as $var)
	{	global ${$var};
		${$var}=array();
	}
}

function GetPathinfo($diskpath, $set)
{	global $disk, $parentdirs, $filename, $ext, $itemtype;

	$pathparts = pathinfo($diskpath);

	//Need to put something to double-check that the ext is really blank
	//and not just a 0.  Same for other fields, possibly... what does it do
	//with files named 0?  Or things whose only parent directory is a 0?
	
	$singlecolonloc=strpos($diskpath, ":");
	$disk[$set]=substr($diskpath, 0, $singlecolonloc);

	$parentdirs[$set]=$pathparts['dirname'];

	$parentdirs[$set] = str_replace("\\", "/", $parentdirs[$set]);
	
	$itemtype[$set]=GetItemType($diskpath);
	//echo $parentdirs[$set];
	
	$singlecolonslashloc=strpos($parentdirs[$set], ":");
	$parentdirs[$set]=substr($parentdirs[$set], $singlecolonslashloc+2);
	//echo " fuck "; echo $parentdirs[$set];
	
	if ($itemtype[$set]=="Dir")
	{	$filename[$set]=$pathparts['basename'];
	}
	else
	{	
		$basename=$pathparts['basename'];
		
		list($thisfn, $thisext)=GetFNExt($basename);
		$ext[$set]=$thisext;
		$filename[$set]=$thisfn;
	}
}

function MakeThumbnail($diskpath, $ext, $id)
{	global $bmp_library_installed, $filesdb_name;
	$lowercasext=strtolower($ext);
	
	if ($lowercasext=="jpg" || $lowercasext=="jpeg")
	{	$img="";
		$img=imagecreatefromjpeg($diskpath);
	}
	else if ($lowercasext=="png")
	{	$img=imagecreatefrompng($diskpath);
	}
	else if ($lowercasext=="gif")
	{	$img=imagecreatefromgif($diskpath);
	}
	else if ($lowercasext=="bmp" && $bmp_library_installed=="yes")
	{	$img=imagecreatefrombmp($diskpath);
	}
	else
	{	return false;
	}
	if (!$img)
	{	return false;
	}
	
	global  $max_tn_width, $max_tn_height, $tn_images_path, $images_per_tn_fol, $datapath;
		
	$width = imagesx( $img );
    $height = imagesy( $img );
	
	if ($width>=$height)
	{	$newwidth=$max_tn_width;
		$newheight=floor(($max_tn_width*$height)/$width);
	}
	else if ($height>$width)
	{	$newheight=$max_tn_height;
		$newwidth=floor(($max_tn_height*$width)/$height);
	}

	// create a new temporary image
    $tmp_img = imagecreatetruecolor( $newwidth, $newheight );

    // copy and resize old image into new image
    imagecopyresized( $tmp_img, $img, 0, 0, 0, 0, $newwidth, $newheight, $width, $height );
	
	$temp=$datapath;
	
	if (!file_exists( $temp ) )
	{	
		mkdir( $temp );
	}
	if (!file_exists($tn_images_path) )
	{	mkdir($tn_images_path);
	}
	
	$output_path_dirs=$tn_images_path . "/$filesdb_name";
	if (!file_exists($output_path_dirs) )
	{	mkdir($output_path_dirs);
	}
	
	$tnfolnum=floor($id/$images_per_tn_fol);
	$tnfolnum++;
	$output_path_dirs=$output_path_dirs . "/" . $tnfolnum;
	
	if (!file_exists($output_path_dirs) )
	{	mkdir($output_path_dirs);
	}
	
	$finaloutputpath=$output_path_dirs . "/$id.jpg";

    // save thumbnail into a file
    imagejpeg( $tmp_img, "$finaloutputpath" );
	return true;
}


function GetFileDetails($diskpath, $set)
{	global $disk, $parentdirs, $filename, $ext, $extcat, $itemtype, $paired, $pairedname, $aspectratio, $reverse_aspectratio, $imagewidth, $imageheight, $imagearea, $wideortall, $showthumbnail, $hasthumbnail, $bmp_library_installed, $tnableimageformats;
	
	GetPathinfo($diskpath, $set);
	
	$paired[$set]="n";	//No by default unless an accompanying file/fol is found.

	if ($itemtype[$set]=="File")
	{
		$lowercasext=strtolower($ext[$set]);
		$extcat[$set]=GetExtCat($lowercasext);

		$possiblefolpath=$disk[$set] . ":/" . $parentdirs[$set] . "/" . $filename[$set] . "_files";

		if (file_exists($possiblefolpath))
		{	
			if (is_dir($possiblefolpath))
			{	$paired[$set]="y";
				$pairedname[$set]=$filename[$set] . "_files";
			}
		}
		
		if (in_array($lowercasext, $tnableimageformats) )
		{	
			if ($lowercasext!="gif" && $lowercasext!="jpg" && $lowercasext!="jpeg" && $lowercasext!="png" && $lowercasext!="bmp")
			{	$showthumbnail[$set]="n";
				$hasthumbnail[$set]="n";
			}//&& $bmp_library_installed=="yes")
			if ($lowercasext=="gif" || $lowercasext=="jpg" || $lowercasext=="jpeg" || $lowercasext=="png" || $lowercasext=="bmp" )
			{	$showthumbnail[$set]="y";
				$hasthumbnail[$set]="y";
			//	if ($lowercasext=="bmp" && $bmp_library_installed!="yes")
			//	{	$hasthumbnail[$set]="n";
			//	}
			}
			
			list($width, $height) = getimagesize($diskpath);
			$aspectratio[$set]=number_format($width/$height, 3);
			$reverse_aspectratio[$set]=number_format($height/$width,3);
			
			if ($width<$height)
			{
				$wideortall[$set]="t";
			}
			else if ($width>$height)
			{
				$wideortall[$set]="w";
			}
			else if ($width==$height)
			{	$wideortall[$set]="s";	//square
				$reverse_aspectratio[$set]=number_format(1, 3);
			}

			$imageheight[$set]=$height;
			$imagewidth[$set]=$width;
			$imagearea[$set]=$width*$height;
		}

	}
	else if ($itemtype[$set]=="Dir")
	{	if ($ext[$set])
		{	$fulldirname=$filename[$set] . "." . $ext[$set];
		}
		else
		{	$fulldirname=$filename[$set];
		}
		$explosion=explode("_", $fulldirname);

		if ($explosion[( count($explosion)-1 ) ]=="files")
		{	array_pop($explosion);

			$possiblefilename=implode("_", $explosion);
			$possiblepathstart=$disk[$set] . ":/" . $parentdirs[$set] . "/";
			
			$possiblefilepathhtm=$possiblepathstart . $possiblefilename . ".htm";
			$possiblefilepathhtml=$possiblepathstart . $possiblefilename . ".html";
			$possiblefilepathshtml=$possiblepathstart . $possiblefilename . ".shtml";
			if (file_exists($possiblefilepathhtm) || file_exists($possiblefilepathhtml) || file_exists($possiblefilepathshtml))
			{	$paired[$set]="y";
			}

			if ( file_exists($possiblefilepathhtm) )
			{	$pairedname[$set]=$possiblefilenamehtm;
			}
			else if ( file_exists($possiblefilepathhtml) )
			{	$pairedname[$set]=$possiblefilenamehtml;
			}
			else if ( file_exists($possiblefilepathshtml) )
			{	$pairedname[$set]=$possiblefilenameshtml;
			}
			else
			{	$pairedname[$set]="";
			}
		}
	}
	return true;
}

function BackToForwardSlashes($inp)
{	if (strpos($inp, "\\"))
	{	$inp = str_replace("\\", "/", $inp);
		//$inp = AddFileLocalhost($inp);
	}
	return $inp;
}

function ConvertFirefoxFormatLocalUrl($inp)
{	if (strpos($inp, "file:///")!==false)
	{
		$inp = ereg_replace("file:///", "file://localhost/", $inp);
		//$inp=Convert20ToSpaces($inp);
	}
	return $inp;
}

function AddFileLocalhost($inp)
{	$inp = "file://localhost/" . $inp;
	return $inp;
}

function FileLocalhostHere($inp)
{	$res=strpos($inp, "file://localhost/");
	if ($res===false)
	{	return false;
	}
	return true;	
}

function SingleColonSlashPresentIn($inp)
{
	$pos=strpos($inp, ":/");
	if ($pos!==false)
	{
		return true;
	}
	else 
	return false;
}

/*function SingleColonSlashAbsentIn($inp)
{
	if (strpos($inp, ":/")!==false)
	{	return false;
	}
	else return true;
}*/

function ProcessRawFilepath($rawfilepath, $set)
{	global $handle;

	//Isn't going to tamper with %20's, so, make sure you don't use them unless
	//they're really a part of the file name and not just taking the place of a space.
	//Really, you're better off renaming all files which have %20's in the file name
	//since they tend to confuse web browsers.

	$convertedfilepath = trim ($rawfilepath);
	$convertedfilepath = BackToForwardSlashes($convertedfilepath);
	$convertedfilepath = ConvertFirefoxFormatLocalUrl($convertedfilepath );

	//First, we strip off file://localhost if it's already there.
	$convertedfilepath=ereg_replace("file://localhost/", "", $convertedfilepath);
	
	$convertedfilepath=StripExtraSlashes($convertedfilepath);

	if (!SingleColonSlashPresentIn($convertedfilepath)) 
		//An indication that the user didn't mention a drive, or just forgot the colon
	{	DisplayWithError($convertedfilepath);
		GoBackToFormWithError("no colonslash");
		exit;
	}

	//Then we strip out any extra, needless slashes the user might have put in.
	$convertedfilepath=StripExtraSlashes($convertedfilepath);

	//There always has to be a : before the first /.
	$firstslashloc=strpos($convertedfilepath, "/");
	$firstcolon=substr($convertedfilepath, $firstslashloc-1, 1);

	if ($firstcolon!=":")
	{	GoBackToFormWithError("misplaced colonslash");
		exit;
	}
	
	if (SingleColonSlashPresentIn($convertedfilepath))	//If :/ present:

	{	//We then find out where the :/ is.
		$singlecolonslashloc=strpos($convertedfilepath, ":/");

		//If the :/ is 1 char ahead of the beginning of the string,
		//there's probably a drive letter before it, but we'll check
		//to make sure.

		if ($singlecolonslashloc==1)
		{	$drivename=substr($convertedfilepath, 0, 1);
			if (!preg_match("/[A-z]/", $drivename))
				//Not a drive letter if it's not A-Z or a-z, so
				//we go back to the form with an error.
			{	GoBackToFormWithError("drive letter");
				exit;
			}
			else	//If it is a drive letter, we make it uppercase.
			{	//$drivename=strtoupper($drivename);
				//$convertedfilepath=substr($convertedfilepath, 3);
			}
		}
		else if ($singlecolonslashloc==0)
		{	GoBackToFormWithError("drive letter");
			exit;
		}
		else //if :/ is anywhere else...
		{	$drivename=substr($convertedfilepath, 0, $singlecolonslashloc);
			//$convertedfilepath=substr($convertedfilepath, $singlecolonslashloc);
		}
	}
	global $disk;
	
	$disk[$set]=$drivename;
	
		//We add file://localhost, and the capitalized drive
		//letter.
	$convertedfilepath = $convertedfilepath;
	
	//Then we count how many :/'s are there.
	$numofsinglecolonslash=substr_count($convertedfilepath, ":/");
	
	//There should never be more than one :/, so if there is, we 
	//send the user back to the form.
	if ($numofsinglecolonslash>1)
	{	GoBackToFormWithError("too many colonslashes");
	}

	$convertedfilepath=rtrim($convertedfilepath,"/");

	//strips out /'s.
	$str=preg_replace("/(\/)+/", ' ', $convertedfilepath);
	
	//If the path contains :*?"<>| - character forbidden in Windows file or dir names -
	//it bounces the user  back to the form.  ( \ / are also forbidden but those get
	//stripped out or converted so we don't look for them )
	$str=substr($convertedfilepath, $singlecolonslashloc+2);

	$badchars=preg_match_all("/:|\*|\?|\"|\<|\>|\|/", $str, $matches);
	$matchstr=implode(" ", $matches[0]);

	if ($badchars>0)
	{	DisplayWithError($matchstr);
		GoBackToFormWithError("badchars");
		exit;
	}
	
	return $convertedfilepath;
}

function MakeFilepathClean($filepath)
{
	$cleanfilepath=$filepath;
	
	CleanInput($cleanfilepath);

	return $cleanfilepath;
}

function UnsetFileDetails($set)
{	
	$varstounset=array("filesize", "extcat", "itemtype", "disk", "parentdirs", "filename", "ext", "filelm", "filecr", "paired", "pairedname");
	//"repository", "contentsimported", "privacylevel", "licensetype", "whenadded", "importdate")
	foreach ($varstounset as $var)
	{	global ${$var};
		${$var}[$set]="";
	}
}

function UnsetImageDetails($set)
{	
	$varstounset=array("imagewidth", "imageheight", "imagearea", "aspectratio", "reverse_aspectratio", "wideortall", "showthumbnail", "hasthumbnail");

	foreach ($varstounset as $var)
	{	global ${$var};
		${$var}[$set]="";
	}
}

function GetExtCat($inp)
{	switch ($inp)
	{
		case "png": 
		case "jpg": 
		case "jpeg":
		case "bmp":
		case "art":
		case "xcf":
		case "psd":
		case "gif":	$res="Image"; break;

		case "mid": 
		case "wav":
		case "aiff":
		case "spc": 
		case "it":
		case "wma":
		case "mp3": $res="Audio"; break;

		case "wmv":
		case "flv":
		case "avi":
		case "mpg":
		case "mpeg": $res="Video"; break;
		
		case "sf2": $res="SoundFont"; break;
		
		case "se1": $res="Swiss Ephemeris"; break;
		
		case "doc": 
		case "rtf":
		case "odt": 
		case "pdf": 
		case "txt": $res="Text"; break;
		
		case "ttf": $res="Font"; break;
		
		case "c":
		case "h":
		case "pl": 
		case "py":
		case "cpp":
		case "bas":
		case "inf":
		case "icl":
		case "php": $res="Source Code"; break;

		case "htm": 
		case "html":
		case "mht":
		case "shtml": $res="Web"; break;
		case "css": $res="Stylesheet"; break;
		
		case "xml": $res="XML"; break;

		case "bak": $res="Backup"; break;
		case "m3u": $res="Playlist"; break;

		
		case "z5":
		case "z8": $res="Interactive Fiction";
		
		case "pfc": $res="AOL Email DB"; break;
		case "sxw": $res="OpenOffice Macro"; break;
		case "db": $res="Thumbnail DB"; break;
		case "lnk": $res="Shortcut"; break;
		case "exe": $res="Executable"; break;
		
		case "zip":
		case "rar":	$res="Compressed"; break; 
		
		case "sea":
		case "hqx":
		case "sit": $res="Mac Compressed"; break;
	}
	return $res;
}
?>