<?php

$includecbs=array("repos", "triv", "obsi", "clut", "todoi", "stati", "listi", "junk", "recuri", "arci", "asidei", "icei", "donei", "hidei", "quesi");

$onlycbs = array("aes", "fv", "imp", "frq", "stat", "todoo", "list", "hum", "util", "edu", "tip", "opi", "arco", "recuro", "fun4", "cur", "reposo", "site4", "cluto", "hideo", "sbk", "trivo", "obs", "obso", "noteo", "junko", "iceo", "tento", "goalo", "ques", "activ", "asideo", "doneo");

$ordercbs = array("reador", "dueor", "noteor", "mdateor", "prior", "rprior", "plauor", "necor", "likeor", "intror", "qualor", "aesor", "utilor", "eduvalor", "funor", "humorder", "modor", "idor", "titleor");

$fullincludevarsnames=array("repos" => "repository", "triv" => "trivial", "obsi" => "obsolete", "clut" => "clutterpile", "todoi" => "todo", "stati" => "status", "listi" => "listitem", "junk" => "junkpile", "recuri" => "recurrent", "arci" => "archive", "asidei" => "aside", "icei" => "iced", "donei" => "done", "hidei" => "hide", "quesi" => "question");


$longdesccommands = array("ld", "longdesc");
$longdescorcommands = array("ldo", "ldor", "longdescor");

$quotecommands = array("q", "qu", "quo", "quote");
$quoteorcommands = array("quor", "quoteor");

$quoteorldcommands = array("qul", "quld", "quold", "quoteorld", "quorld", "quoteorlongdesc");
$quoteorldorcommands = array("qulo", "qulor", "quldor", "quoldor", "quoteorldor", "quorldor", "quoteorlongdescor");

$titlecommands = array ("ti", "title");
$titleorcommands = array ("to", "tor", "titleor");
$titlexcommands = array ("tx", "titlex", "exactitle");

$precommands = array("pr", "pre");

$usesymbolscommands = array("sy", "sym", "symb", "symbols");
$nosymbolscommands = array("nsy", "nosym", "nosymb", "nosymbols");

$pagenumcommands = array ("p", "page");
$ideanumcommands = array ("#", "n", "i#", "ideas", "ideanum", "ideasnum");

$ignorecbcommands = array ("ic", "cb", "ccb", "igc", "igcb", "ignorecb", "ignorecheckboxes", "clearcb", "clearcheckboxes");
$ignoreincludecbcommands = array("igi", "iginc", "ignoreinc", "ignoreincs");
$ignoreonlycbcommands = array("igo", "igonly", "ignoreonly", "ignoreonlys");
$ignoreordercbcommands = array("io", "ior", "igor", "igorders", "ignoreorder", "ignoreorders");

$ascs=array("a", "as", "asc");
$descs=array("d", "de", "des", "desc");
$lastreadcommands = array("lr", "read", "lastread");

$ordercommands = array("o", "or", "ord", "order");

$read_abrev=array("read", "lastread", "whenread");
$fin_abrev=array("du", "due", "fbd", "fin", "finish");
$noted_abrev=array("wn", "note", "noted");
$mdate_abrev=array("da", "dat", "md", "mdate");
$prio_abrev=array("pr", "pri", "prio", "prior");
$rprio_abrev=array("rp", "rpr", "rpri", "rprio", "rprior");
$plau_abrev=array("pla", "plau", "plaus", "plaus");
$nec_abrev=array("ne", "nec");
$lik_abrev=array("li", "lik", "like");
$int_abrev=array("in", "int", "intr");
$qual_abrev=array("qu", "qua", "qual");
$beau_abrev=array("ae", "aes", "bea", "beau");
$use_abrev=array("us", "ut", "use", "uti", "util");
$eduv_abrev=array("ed", "edu", "educ", "eduv");
$funv_abrev=array("fu");
$humv_abrev=array("hu", "hum", "humor");
$title_abrev=array("ti", "titl");
$mod_abrev=array("mo", "mod", "lm");
$add_abrev=array("ad", "add", "added");
$unhid_abrev=array("unh", "unhi", "unhid", "unhidden");
$id_abrev=array("id", "ideaid");

$listoforders=array("lastread", "finishbydate", "whenoted", "date", "priority", "rpriority", "plausibility", "necessity", "liking", "interest", "quality", "beauty", "usefulness", "eduval", "fun", "humorousness", "whenmodified", "whenadded", "idea_id", "title");

$order_abrev_arrs=array("read_abrev" => "lastread", "fin_abrev" => "finishbydate", "noted_abrev" => "whenoted", "mdate_abrev" => "date", "prio_abrev" => "priority", "rprio_abrev" => "rpriority", "plau_abrev" => "plausibility", "nec_abrev" => "necessity", "lik_abrev" => "liking", "int_abrev" => "interest", "qual_abrev" => "quality", "beau_abrev" => "beauty", "use_abrev" => "usefulness", "eduv_abrev" => "eduval", "funv_abrev" => "fun", "humv_abrev" => "humorousness", "title_abrev" => "title", "mod_abrev" => "whenmodified", "add_abrev" => "whenadded", "id_abrev" => "idea_id");

function ExpandOrderAbbrev(&$inp)
{	global $order_abrev_arrs;
	foreach ($order_abrev_arrs as $arr => $key)
	{	global ${$arr};
		if (in_array ($inp, ${$arr} ) )
		{	
			$inp = $key; return;
		}
	}
}

$onlycommands = array ("only", "y", "is", "has", "yes", "in", "of", "ol", "onl", "on");

$attributes = array ("repository", "trivial", "fav", "archive", "aside", "clutterpile", "junkpile", "important", "listitem", "status", "aesthetic", "utilit", "forfun", "educational", "humorous", "curio", "observation", "tip", "opinion", "frequent", "question", "scrapbook", "activity", "todo", "note", "forsite", "usedonsite", "done", "iced", "redundant", "quotebelow", "forother", "goal", "hide", "definite", "tentative", "obsolete", "recurrent", "longdesc", "unhide");

$ld_abrev=array("ld", "lde", "ldesc", "longdesc");
$rep_abrev=array("re", "rep", "repo", "repos");
$sbk_abrev=array("sb", "sc", "scr", "scrap", "book");
$act_abrev=array("ac", "act", "acti", "activ");
$todo_abrev=array("to", "tod");
$note_abrev=array("no", "not");
$done_abrev=array("don");
$iced_abrev=array("ic", "ice");
$redun_abrev=array("re", "red", "redu", "redun");
$qb_abrev=array("qb", "quob");
$triv_abrev=array("tri", "triv");
$list_abrev=array("li", "lis", "list", "listi");
$fav_abrev=array("fv", "fa", "favo", "favor", "favorite");
$maybe_abrev=array("mb", "ma", "may", "mayb");
$listi_abrev=array("li", "lis", "list", "listi");
$stat_abrev=array("st", "sta", "stat");
$clut_abrev=array("clu", "clu", "clut", "clutr");
$junk_abrev=array("jn", "jk", "jun", "jnk", "junk");
$imp_abrev=array("im", "imp", "impo", "import");
$aes_abrev=array("ae", "aes", "aesth");
$util_abrev=array("ut", "uti", "util", "utilitarian");
$fun_abrev=array("fu", "fun");
$hum_abrev=array("hu", "hum", "humor");
$cur_abrev=array("cu", "cur", "curi");
$obs_abrev=array("ob", "obs", "observ");
$obso_abrev=array("obso", "obsol");
$tip_abrev=array("t", "ti");
$opi_abrev=array("op", "opi", "opin");
$frq_abrev=array("fr", "fre", "frq", "freq");
$qu_abrev=array("q", "qu", "que", "ques", "?");
$foth_abrev=array("fo", "foth", "foro");
$goal_abrev=array("go", "goa");
$hide_abrev=array("hi", "hid", "hidden");
$def_abrev=array("de", "def", "defi", "defin");
$tent_abrev=array("te", "tent", "tenta");
$asi_abrev=array("as", "asi", "asid");
$edu_abrev=array("edu", "educ");
$arc_abrev=array("ar", "arc", "arch", "archi", "archiv");

$site4_abrev=array("si", "4s", "4site", "site");
$usedsite4_abrev=array("ud", "usd", "used");


$abrev_arrs=array("rep_abrev" => "repository", "triv_abrev" => "trivial", "fav_abrev" => "fav", "arc_abrev" => "archive", "asi_abrev" => "aside", "clut_abrev" => "clutterpile", "junk_abrev" => "junkpile", "imp_abrev" => "important", "list_abrev" => "listitem", "stat_abrev" => "status",  "aes_abrev" => "aesthetic", "util_abrev" => "utilit", "edu_abrev" => "educational", "fun_abrev" => "forfun", "hum_abrev" => "humorous", "cur_abrev" => "curio", "obs_abrev" => "observation", "tip_abrev" => "tip", "opi_abrev" => "opinion", "frq_abrev" => "frequent", "qu_abrev" => "question", "sbk_abrev" => "scrapbook", "act_abrev" => "activity", "todo_abrev" => "todo", "note_abrev" => "note", "site4_abrev" => "forsite", "usedsite4_abrev" => "usedonsite", "done_abrev" => "done", "iced_abrev" => "iced", "redun_abrev" => "redundant", "qb_abrev" => "quotebelow", "foth_abrev" => "forother", "goal_abrev" => "goal", "hide_abrev" => "hide", "def_abrev" => "definite", "tent_abrev" => "tentative", "ld_abrev" => "longdesc", "obso_abrev" => "obsolete");

function ExpandAbbrev(&$inp)
{	global $abrev_arrs;
	
	foreach ($abrev_arrs as $arr => $key)
	{	global ${$arr};
		if (in_array ($inp, ${$arr} ) )
		{	$inp = $key; 
			return;
		}
	}
}

$includecommands = array ("i", "inc", "incl", "inclu", "include");

$includeattributes = array("repository", "trivial", "obsolete", "clutterpile", "todo", "status", "listitem", "recurrent", "archive", "aside", "iced", "done", "hide", "question", "junkpile");


$includeallcommands = array("ia", "inca", "incall", "includeall");
$includeintcommands = array("ii", "inci", "incint");
$includetypcommands = array("it", "ty", "ityp", "typ", "typical");
$includequestioncommands = array("iq", "incq", "?", "??", "???");

$excludecommands = array ("x",  "exclude", "xc", "xcl", "xclude", "n", "no", "not", "isnt", "hasnt", "notin", "notof");

$cats=array("aesthetic", "utilit", "educational", "forfun", "humorous", "curio");

$excludeallmaincats = array("xa", "xac", "xamc", "excludeallmaincats");
$excludeothermaincats = array("xc", "xoc", "excludeothercats");

$excludeboringcommands = array("xb", "exb", "excludeboring");
$excludesubtagcommands = array("ns", "nsb", "nst", "nosub", "nosubtag");


$anytagcommands = array("t", "tg", "ta", "tag", "tags", "at", "anyt", "anytag");
$anytagorcommands = array("tao", "tago", "tagso", "tagsor", "tagor", "ato", "ator", "anytagor");

$maintagcommands = array ("mta", "mtag", "mtags", "maintag", "maintags");
$maintagorcommands = array("mtao", "mtago", "mtagso", "maintagor", "maintagsor");

$othertagcommands = array ("ot", "oth", "otht", "othert", "othertag", "othertags");
$othertagorcommands = array ("oto", "otor", "othertagor", "othertagsor");

$projectagcommands = array ("pj", "pt", "prj", "pjt", "projt", "projectag", "project");
$projectagorcommands = array("pjo", "pjor", "ptor", "pjtor", "projtor", "projectagor", "projector");

$bundletagcommands = array("bu", "bt", "bun", "but", "bundt", "bund", "bundle", "bundletag");
$bundletagorcommands = array("bto", "buto", "butor", "bundtor", "bundor", "bundleor", "bundletagor");

$otherbundletagcommands = array("obu", "obt", "obun", "obut", "obundt", "obund", "obundle", "obundletag", "otherbundletag");
$otherbundletagorcommands = array("obuo", "obuor");

$authortagcommands = array("au", "aut", "auth", "autag", "author", "authortag");
$authortagorcommands = array("auo", "auor", "autor", "autagor", "authoror", "authortagor");

$languagetagcommands = array ("la", "lan", "lang", "langs", "language", "languages");
$languagetagorcommands = array("lano", "lanor", "langor", "languageor", "languagesor");

$origintagcommands = array("from", "orign", "origin", "origintag");
$origintagorcommands = array("from", "fromor", "origino", "origintago");

$loctagcommands = array("loc", "location", "venue", "loctag");
$loctagorcommands = array("loco", "locationo", "venuo", "venueo", "loctago");

$tofortagcommands = array("to", "for", "fortag", "totag", "tofor", "fortag");
$tofortagorcommands = array("too", "foro", "fortago", "totago", "toforo", "fortago", "foror", "toor");


$allanytagcommands = array_merge($anytagcommands, $anytagorcommands);
$allmaintagcommands = array_merge($maintagcommands, $maintagorcommands);
$allothertagcommands = array_merge($othertagcommands, $othertagorcommands);
$allprojectagcommands = array_merge($projectagcommands, $projectagorcommands);
$allbundletagcommands = array_merge($bundletagcommands, $bundletagorcommands);
$allotherbundletagcommands = array_merge($otherbundletagcommands, $otherbundletagorcommands);
$allauthortagcommands = array_merge($authortagcommands, $authortagorcommands);
$alllanguagetagcommands = array_merge($languagetagcommands, $languagetagorcommands);
$allloctagcommands = array_merge($loctagcommands, $loctagorcommands);
$alltofortagcommands = array_merge($tofortagcommands, $tofortagorcommands);
$allorigintagcommands = array_merge($origintagcommands, $origintagorcommands);

$alltagorcommands = array_merge($anytagorcommands, $maintagorcommands, $othertagorcommands, $projectagorcommands, $bundletagorcommands, $authortagorcommands, $languagetagorcommands, $loctagorcommands, $tofortagorcommands, $otherbundletagorcommands, $origintagorcommands);

$tagtablecommands = array();
$tagtablecommands = array_merge($anytagcommands, $anytagorcommands, $maintagcommands, $maintagorcommands, $othertagcommands, $othertagorcommands, $projectagcommands, $projectagorcommands, $bundletagcommands, $bundletagorcommands, $authortagcommands, $authortagorcommands, $languagetagcommands, $languagetagorcommands, $tofortagcommands, $tofortagorcommands, $loctagcommands, $loctagorcommands, $otherbundletagcommands, $otherbundletagorcommands, $origintagcommands, $origintagorcommands);

$list_allcommandarrays=array("longdesccommands", "longdescorcommands", "titlecommands", "titleorcommands", "titlexcommands", "anytagcommands", "anytagorcommands", "maintagcommands", "maintagorcommands", "othertagcommands", "othertagorcommands", "projectagcommands", "projectagorcommands", "bundletagcommands", "bundletagorcommands", "authortagcommands", "authortagorcommands", "languagetagcommands", "languagetagorcommands", "onlycommands", "excludecommands", "includecommands", "ordercommands", "includeintcommands", "includetypcommands", "includeallcommands", "ignoreincludecbcommands", "ignoreonlycbcommands", "ignorecbcommands", "ignoreordercbcommands", "pagenumcommands", "ideanumcommands", "excludeboringcommands", "excludesubtagcommands", "excludeallmaincats", "excludeothermaincats", "ascs", "descs", "lastreadcommands", "includequestioncommands", "usesymbolscommands", "nosymbolscommands", "precommands", "quotecommands", "quoteorcommands", "quoteorldcommands", "quoteorldorcommands", "otherbundletagcommands", "otherbundletagorcommands", "loctagcommands", "loctagorcommands", "tofortagcommands", "tofortagorcommands", "origintagcommands", "origintagorcommands");

$allcommands = array();

foreach ($list_allcommandarrays as $arr)
{
	$allcommands = array_merge( $allcommands, ${$arr} );
}

function TagSubquery ($inornot, $likeorin, $tagidnums, $tagtypestuff)
{
	$res="\nAND ideainfo.idea_id $inornot
(
		SELECT ideainfo.idea_id 
		FROM ideainfo, tags, ideatagmap 
		WHERE ideainfo.idea_id = ideatagmap.idea_id 
		AND Tags.tag_id = ideatagmap.tag_id
		AND
		( 
			(	Tags.tag_name $likeorin ($tagidnums)  $tagtypestuff
			)
		)
)";
	return $res;
}


function GetTagidStringFromTagArr($arr)
{	global $array_existingtagsandids;

	$numoftags=count($arr);
	$x=0;
	while ($x<$numoftags)
	{	$tagname=$arr[$x];
		$thistagid[$x]=$array_existingtagsandids[$tagname];
		$tagids .= "$thistagid[$x], ";
		$x++;
	}
	$tagids=substr($tagids, 0, -2);
	return $tagids;
}


function ParseSearchQuery($searchquery, $dontsavexq=false)
{	global $list_allcommandarrays;

	foreach ($list_allcommandarrays as $arr)
	{	global ${$arr};
	}
	
    global $tagtablecommands, $allcommands, $alllikecommands, $alllabelcommands,     
  $lengthcomparecommands,  $num_of_args, $indiv_args, $outlist, $inlist,  $displaylinks, $displayeditlinks, $outputeditfile, $outputsearch,  $allanytagcommands, $tagtablequery, $alltagorcommands, $prevtagcommandissued, $allmaintagcommands, $allothertagcommands, $allprojectagcommands, $allbundletagcommands, $allauthortagcommands, $alllanguagetagcommands, $attributes, $listoforders, $asc, $ascs, $descs, $executequery, $thisearchquery, $cats, $includeattributes, $alltofortagcommands, $allloctagcommands, $allotherbundletagcommands;

	$searchquery=ereg_replace("\n", ";;\n", $searchquery);
  	$thisearchquery=$searchquery;

	$indiv_commands=explode(";;", $searchquery);

	array_walk($indiv_commands,trim_value);

	$num_of_commands=count($indiv_commands);


	$x=0;
	while ($x<$num_of_commands)
	{
		$splitcommand=explode(" ", $indiv_commands[$x]);
		$thiscommand=array_shift($splitcommand);
		$thiscommand=strtolower($thiscommand);
		$len=strlen($thiscommand);

		$args=substr($indiv_commands[$x],$len);
		
		$indiv_args=explode(";", $args);

		array_walk($indiv_args,trim_value);

		$num_of_args=count($indiv_args);

		$test=substr($thiscommand, 0, 1);
		if ($test=="!")
		{	$negcommand=substr($thiscommand,1);
		}

	if ( in_array($thiscommand, $allcommands) )
	{
		if ( in_array($thiscommand, $excludeothermaincats) )
		{	
			global $aes, $util, $edu, $fun4, $hum, $nws, $cur;

			$catshash=array("aes" => "aesthetic", "util" => "utilit", "edu" => "educational", "fun4" => "forfun", "hum" => "humorous", "cur" => "curio");
			foreach ($catshash as $catvar => $catname)
			{	if (${$catvar}!="y")
				{
					$query_part2 .= "\nAND ideainfo.$catname = 'n' ";
				}
			 }
			 $executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand, $excludeallmaincats) )
		{
			foreach ($cats as $cat)
			{
				$query_part2 .= "\nAND ideainfo.$cat = 'n' ";
			}
		}
		else if ( in_array($thiscommand, $ascs) )
		{	global $asc;
			$asc="asc";
		}
		else if ( in_array($thiscommand, $descs) )
		{	global $asc;
			$asc="desc";
		}
		else if ( in_array($thiscommand, $excludesubtagcommands) )
		{	
			global $excludesubtags;
			$excludesubtags=true;
		}
		else if ( in_array($thiscommand, $lastreadcommands) )
		{	global $asc, $reador;
			$asc="asc";
			$reador="y";
		}
		else if ( in_array($thiscommand, $usesymbolscommands) )
		{	global $usesymbols;
			$usesymbols="y";
		}
		else if ( in_array($thiscommand, $precommands) )
		{	global $usepre;
			$usepre="y";
		}
		else if ( in_array($thiscommand, $nosymbolscommands) )
		{	global $usesymbols;
			$usesymbols="n";
		}
		else if ( in_array($thiscommand, $tagtablecommands) )
		{
			$tagtablequery="true";
			if (!$dontsavexq)
			{
				$executequery=$thisearchquery;
			}
			global $array_existingtagsandids;
			$tagtablequery=true;

			$outlist = array();
			$inlist = array();

			$likeorin="IN";
			$enclosure="\"";

			array_walk($indiv_args, ArrayWalkInOrNot);
			$tagtypestuff = " AND ideatagmap.tagtypenum IN ";

			if ( in_array($thiscommand,$allanytagcommands ) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(1, 3, 5, 7, 9, 11, 13, 15, 17, 19)";
				}
				else
				{	$tagtypestuff = "";
				}
			}

			else if ( in_array($thiscommand,$allmaintagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(1)";
				}
				else
				{
					$tagtypestuff .= "(1, 2)";
				}
			}
			else if ( in_array($thiscommand,$allothertagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(3)";
				}
				else
				{
					$tagtypestuff .= "(3, 4)";
				}
			}
			else if ( in_array($thiscommand,$allprojectagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(5)";
				}
				else
				{
					$tagtypestuff .= "(5, 6)";
				}
			}
			else if ( in_array($thiscommand,$allbundletagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(7, 13)";
				}
				else
				{
					$tagtypestuff .= "(7, 8, 13, 14)";
				}
			}
			else if ( in_array($thiscommand,$allauthortagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(9)";
				}
				else
				{	$tagtypestuff .= "(9, 10)";
				}
			}
			else if ( in_array($thiscommand,$alllanguagetagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(11)";
				}
				else
				{	$tagtypestuff .= "(11, 12)";
				}
			}
			else if ( in_array($thiscommand,$allotherbundletagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(13)";
				}
				else
				{	$tagtypestuff .= "(13, 14)";
				}
			}
			else if ( in_array($thiscommand,$alltofortagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(15)";
				}
				else
				{	$tagtypestuff .= "(15, 16)";
				}
			}
			else if ( in_array($thiscommand,$allloctagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(17)";
				}
				else
				{	$tagtypestuff .= "(17, 18)";
				}
			}
			else if ( in_array($thiscommand,$allorigintagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(19)";
				}
				else
				{	$tagtypestuff .= "(19, 20)";
				}
			}
			if (!empty ($inlist) )
			{			
				array_walk($inlist,EncloseInSomething, $enclosure);
				$num_of_in=count($inlist);
				$regluedin=implode(", ", $inlist);
			}
			if (!empty ($outlist) )
			{
				array_walk($outlist,EncloseInSomething, $enclosure);
				$num_of_out=count($outlist);
				$regluedout=implode(", ", $outlist);
			}

			if ( in_array($thiscommand, $alltagorcommands) )
			{
				if (!$prevtagcommandissued)
				{
					if ( isset($regluedin) )
					{	if ($likeorin=="IN")
						{
							$query_part2 .= "\nAND ( (Tags.tag_name $likeorin ($regluedin) ) $tagtypestuff )";
						}
						else
						{	$y=0;
							$query_part2 .= "\nAND ( (";
							while ($y<$num_of_in)
							{	$thisarg=$inlist[$y];
								if ($y>0)
								{	$query_part2 .= "OR";
								}
								$query_part2 .=  " ( Tags.tag_name $likeorin ($thisarg) ) ";
								$y++;
							}
							$query_part2 .= ") $tagtypestuff )";
						}
					}
					if ( isset($regluedout) )
					{
						$query_part2 .= TagSubquery("NOT IN", $likeorin, $regluedout, $tagtypestuff);
					}
				}
				else if ($prevtagcommandissued)
				{	if ( isset($regluedin) )
					{
						$query_part2 .= TagSubquery("IN", $likeorin, $regluedin, $tagtypestuff);
					}
					if ( isset($regluedout) )
					{
						$query_part2 .= TagSubquery("NOT IN", $likeorin, $regluedout, $tagtypestuff);	
					}
				}
			}
			else //if (! in_array($thiscommand, $alltagorcommands) ) //If it's not an "or" command...
			{	if ($likeorin=="IN")
				{	$likeorin="=";
				}
				$z=0;
				if ( !empty ($inlist) )
				{	if (!$prevtagcommandissued)
					{	$thisarg=$inlist[0];
						$query_part2 .= "\nAND ( (Tags.tag_name $likeorin $thisarg ) $tagtypestuff )";
						$z=1;
					}
					while ($z<$num_of_in)
					{
						$thisarg=$inlist[$z];
						$query_part2 .= TagSubquery("IN", $likeorin, $thisarg, $tagtypestuff);
						$z++;
					}
					$z=0;
				}
				if ( !empty ($outlist) )
				{
					while ($z<$num_of_out)
					{
						$thisarg=$outlist[$z];
						$query_part2 .= TagSubquery("NOT IN", $likeorin, $thisarg, $tagtypestuff);
						$z++;
					}
				}
			}
			unset($regluedin);
			unset($regluedout);

			$prevtagcommandissued="true";
		}
		else
		if ( in_array($thiscommand,$ideanumcommands) )
		{	$thisideanum=$indiv_args[0];
			if (is_numeric($thisideanum) )
			{	global $displaythismany;
				$displaythismany=$thisideanum;
			}
		}
		else if ( in_array($thiscommand,$pagenumcommands) )
		{	$thispagenum=$indiv_args[0];
			if (is_numeric($thispagenum) )
			{	global $page;
				$page=$thispagenum;
			}
		}
		else if ( in_array($thiscommand,$longdesccommands) )
		{	$query_part2 .= ConstructTextSearchQuery("longdesc", "LIKE", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$longdescorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("longdesc", "LIKE", "SingleQuoted", true);
			$executequery=$thisearchquery;
		}		
		else if ( in_array($thiscommand,$quotecommands) )
		{	$query_part2 .= ConstructTextSearchQuery("quote", "LIKE", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$quoteorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("quote", "LIKE", "SingleQuoted", true);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$quoteorldcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("quote", "LIKE", "SingleQuoted", false, "longdesc");
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$quoteorldorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("quote", "LIKE", "SingleQuoted", true, "longdesc");
			$executequery=$thisearchquery;
		}		
		else if ( in_array($thiscommand,$titlecommands) )
		{	$query_part2 .= ConstructTextSearchQuery("title", "LIKE", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$titleorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("title", "LIKE", "SingleQuoted", true);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand, $titlexcommands) )
		{
			$query_part2 .= ConstructTextSearchQuery("title", "=", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		
		else if ( in_array($thiscommand,$excludeboringcommands ) )
		{	global $clut, $junk, $donei, $icei, $hidei, $obsi;
			$clut=""; $junk=""; $donei=""; $icei=""; $hidei=""; $obsi=""; 
		}
		else if ( in_array($thiscommand,$includequestioncommands) )
		{	global $repos, $triv;
			$repos="y"; $triv="y";
		}
		else if ( in_array($thiscommand,$includetypcommands) )
		{	global $todoi, $stati, $arci, $quesi, $recuri;
			$todoi="y"; $stati="y"; $arci="y"; $quesi="y"; $recuri="y";
		}
		else if ( in_array($thiscommand,$includeintcommands ) )
		{
			global $listi, $todoi, $stati, $arci, $asidei, $quesi, $recuri;
			$listi="y"; $todoi="y"; $stati="y"; $arci="y"; $asidei="y"; $quesi="y"; $recuri="y";
		}
		else if ( in_array($thiscommand,$includeallcommands ) )
		{
			global $repos, $triv, $listi, $clut, $icei, $todoi, $stati, $arci, $junk, $donei, $quesi, $recuri, $asidei, $obsi; $hidei;
			$repos="y"; $triv="y"; $listi="y"; $clut="y"; $icei="y"; $todoi="y"; $stati="y"; $arci="y";
			$junk="y"; $donei="y"; $quesi="y"; $recuri="y"; $asidei="y"; $obsi="y"; $hidei="y";
		}
		else if ( in_array($thiscommand, $ignorecbcommands ) )
		{	global $onlycbs, $includecbs, $ordercbs;
			$allcbs=array_merge($onlycbs, $includecbs, $ordercbs);

			foreach ($allcbs as $var)
			{	global ${$var};
				${$var}="";
			}
		}
		else if ( in_array($thiscommand, $ignoreordercbcommands ) )
		{	global $ordercbs;
			foreach ($ordercbs as $var)
			{	global ${$var};
				${$var}="";
			}
		}
		else if ( in_array($thiscommand, $ignoreonlycbcommands ) )
		{	global $onlycbs;
			foreach ($onlycbs as $var)
			{	global ${$var};
				${$var}="";
			}
		}
		else if ( in_array($thiscommand, $ignoreincludecbcommands ) )
		{	global $includecbs;
			foreach ($includecbs as $var)
			{	global ${$var};
				${$var}="";
			}
		}
		else if ( in_array($thiscommand,$onlycommands) )
		{	$y=0;
			$executequery=$thisearchquery;
			global $fullonlyvarnames;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (!in_array($thisarg, $attributes) )
				{
					ExpandAbbrev($thisarg);
				}
				if (in_array($thisarg, $attributes))
				{
					if ($thisarg=="longdesc")
					{	$query_part2 .= "\nAND longdesc IS NOT NULL ";
					}
					if ($thisarg!="forsite" && $thisarg!="usedonsite" && $thisarg!="gone" && $thisarg!="shortdesc")
					{	$query_part2 .= "\nAND ideainfo.$thisarg = 'y' ";
					}
					else if ($thisarg=="usedonsite")
					{	$query_part2 .= "\nAND forsite = 'used' ";
						$executequery=$thisearchquery;
					}
				
					$keyname=array_search($thisarg, $fullonlyvarnames);
					if ($keyname!==false)
					{	global ${$keyname};
						${$keyname}="y";
					}
					
				}
				$y++;
			}
		}
		else if ( in_array($thiscommand, $includecommands) )
		{
			$y=0;
			global $fullincludevarsnames;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (!in_array($thisarg, $includeattributes) )
				{
					ExpandAbbrev($thisarg);
				}
				if (in_array($thisarg, $includeattributes))
				{	
					$keyname=array_search($thisarg, $fullincludevarsnames);
					if ($keyname!==false)
					{	global ${$keyname};
						${$keyname}="y";
					}
				}
				$y++;
			}
		}
		else if ( in_array($thiscommand,$ordercommands) )
		{	$y=0;

			$executequery=$thisearchquery;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (strpos($thisarg, " ")==true)
				{
					$splitarg=explode(" ", $thisarg);
					$ascordesc=strtolower($splitarg[1]);

					if (in_array($ascordesc, $ascs) )
					{	$ascordesc="asc";
					}
					else
					if (in_array($ascordesc, $descs) )
					{	$ascordesc="desc";
					}
					if (!$ascordesc)
					{
						global $asc;
						$ascordesc=$asc;
					}
					$thisorder=$splitarg[0];
				}
				else
				{	global $asc;
					$ascordesc=$asc;
					$thisorder=$thisarg;
				}
				
				global $order;
				if (!in_array($thisorder, $listoforders) )
				{	
					ExpandOrderAbbrev($thisorder);
				}
				if (in_array($thisorder, $listoforders) )
				{	
					if ($thisorder!="date")
					{	$finalorder="ideainfo.$thisorder $ascordesc";
					}
					else
					{	$finalorder="ideainfo.maindateyear $ascordesc, ideainfo.maindatemonth $ascordesc, ideainfo.maindateday $ascordesc, ideainfo.maindatetime $ascordesc";
					}
					
					if (!$ordercommandissued)
					{	$order = "$finalorder";
						global $ordercbs;
						foreach ($ordercbs as $var)
						{	global ${$var};
							${$var}="";
						}
					}
					else
					{	$order .= ", $finalorder";
					}
					global $ordercommandissued;
					$ordercommandissued=true;
				}
				$y++;
			}
		}
		else if ( in_array($thiscommand,$excludecommands) )
		{	$y=0;
			$executequery=$thisearchquery;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (!in_array($thisarg, $attributes) )
				{
					ExpandAbbrev($thisarg);
				}

				if (in_array($thisarg, $attributes))
				{
					switch ($thisarg)
					{	case "repository": global $repos, $reposo; $repos=""; $reposo=""; break;
						case "trivial": global $triv, $trivo; $triv=""; $trivo=""; break;
						case "listitem": global $listi, $list; $listi=""; $list=""; break;
						case "clutterpile": global $clut, $cluto; $clut=""; $cluto=""; break;
						case "iced": global $iceo, $icei; $icei=""; $iceo=""; break;
						case "todo": global $todoo, $todoi; $todoo=""; $todoi=""; break;
						case "status": global $stat, $stati; $stat=""; $stati="";  break;
						case "archive": global $arci, $arco; $arci=""; $arco=""; break;
						case "junkpile": global $junk, $junko; $junk=""; $junko=""; break;
						case "done": global $doneo, $donei; $donei=""; $doneo=""; break;
						case "question": global $ques, $quesi; $ques=""; $quesi=""; break;
						case "recurrent": global $recuri, $recuro; $recuro=""; $recuri=""; break;
						case "aside": global $asidei, $asideo; $asidei=""; $asideo==""; break;
						case "obsolete": global $obso, $obsi; $obso=""; $obsi=""; break;
						case "hide": global $hideo, $hidei; $hidei=""; $hideo=""; break;						
						case "forsite": $query_part2 .= "\nAND ideainfo.forsite != 'unused' "; break;
						case "usedonsite": $query_part2 .= "\nAND ideainfo.forsite != 'used' "; break;
						
						case "fav": 
						case "important":
						case "frequent":
						case "tip":
						case "opinion":
						case "scrapbook":
						case "observation":
						case "note":
						case "tentative":
						case "goal":
						case "definite":
						case "activity":
						case "aesthetic":
						case "utilit":
						case "educational":
						case "forfun":
						case "humorous":
						case "curio": $query_part2 .= "\nAND ideainfo.$thisarg = 'n' "; break;
					}
				}
				$y++;
			}
		}
	}
	$x++;

	}
	return $query_part2;
}


function ConstructLengthComparisonQuery($field, $comparison)
{	global $indiv_args, $thisearchquery, $executequery;

	$executequery=$thisearchquery;
	$thisarg=$indiv_args[0];
	$quer = "AND vgSongDetails.$field $comparison $thisarg";
	return $quer;
}

function ConstructTextSearchQuery($field, $comparison, $quotesornot, $forceor, $secondfield=0)
{	global $num_of_args, $indiv_args, $outlist, $inlist;

	$outlist = array();
	$inlist = array();

	array_walk($indiv_args, ArrayWalkInOrNot);

	$num_of_out=count($outlist);
	$num_of_in=count($inlist);

	if (!$secondfield)
	{	$loops=1;
	}
	else
	{	$loops=2;
	}
	
	$w=0;
	while ($w<$loops)
	{
		if ( !empty($inlist) )

		{	$y=0;
			if ($w==0)
			{	$quer .= " AND (";
			}
			else
			{	$quer .= " OR (";
			}
			while ($y<$num_of_in)
			{	$thisarg=$inlist[$y];
				CleanInput($thisarg);
				if ($comparison=="LIKE")
				{	$thisarg = "%" . $thisarg . "%";
				}
				if ($quotesornot=="SingleQuoted")
				{	$thisarg = "'" . $thisarg . "'";
				}
				else if ($quotesornot=="DoubleQuoted")
				{	$thisarg = "\"" . $thisarg . "\"";
				}
				if ($y>0)
				{	if ($comparison=="LIKE" && $forceor==false)
					{	$quer .= "\nAND";
					}
					else
					{	$quer .= "\nOR";
					}
				}
				$quer .= " ideainfo.$field $comparison $thisarg";
				$y++;
			}
			$quer .= ")";
		}

		if ( !empty($outlist) )
		{	$y=0;
			$quer .= " AND (";

			while ($y<$num_of_out)
			{	$thisarg=$outlist[$y];
				CleanInput($thisarg);
				if ($comparison=="LIKE")
				{	$thisarg = "%" . $thisarg . "%";
				}
				if ($quotesornot=="SingleQuoted")
				{	$thisarg = "'" . $thisarg . "'";
				}
				else if ($quotesornot=="DoubleQuoted")
				{	$thisarg = "\"" . $thisarg . "\"";
				}
				if ($comparison=="=")
				{	$finalcompare="!=";
				}
				else if ($comparison=="LIKE")
				{	$finalcompare="NOT LIKE";
				}
				if ($y>0 && $forceor==false)
				{	$quer .= "\nAND";
				}
				else if ($y>0 && $forceor==true)
				{	$quer .= "\nOR";
				}

				$quer .= " ideainfo.$field $finalcompare $thisarg";
				$y++;
			}
			$quer .= ")";
		}
	$w++;
	$field=$secondfield;
	}
	return $quer;
};


function ArrayWalkInOrNot($inp)
{	global $outlist, $inlist;

	$test=substr($inp, 0, 1);
	if ($test=="!")
	{	$res=substr($inp,1);
		$res=trim($res);
		array_push($outlist,$res);
	}
	else
	{
		array_push($inlist,$inp);
	}
}

function EncloseInSomething(&$value, $key, $enclosure)
{
	$reverse_enclosure=strrev($enclosure);
	$value = $enclosure . $value . $reverse_enclosure;
}

function trim_value(&$value) 
{
    $value = trim($value);
}
?>